# frozen_string_literal: true

module BucketCake
  module TimeHelper
    def hour_cursor(prefix, time)
      "#{prefix}/#{time.utc.strftime('%Y/%m/%d/%H')}.gz"
    end

    def minute_cursor(prefix, time)
      "#{prefix}/#{time.utc.strftime('%Y/%m/%d/%H%M')}.gz"
    end

    def hour_keys(prefix, start_time, end_time)
      Enumerator.new do |y|
        while start_time < end_time
          y << hour_cursor(prefix, start_time)
          start_time += 1.hour
        end
      end
    end

    def assert_time(time)
      raise 'Invalid time: must be a Time object' unless time.is_a?(Time)
      raise 'Invalid time: must be at start of hour' if time.beginning_of_hour != time
    end
  end
end
